Index: XIOS/xios_training/hands-on-3/Makefile
===================================================================
--- XIOS/xios_training/hands-on-3/Makefile	(revision 2064)
+++ 	(revision )
@@ -1,22 +1,0 @@
-# Compilateur
-FC = mpif90
-# Variables
-XIOS_DIR = ../xios_build
-# Includes
-FCFLAGS= -I$(XIOS_DIR)/inc  -I$(NETCDF_INCDIR)
-# Librairies
-LDFLAGS = -L$(XIOS_DIR)/lib -lxios $(NETCDFLIBS) -lstdc++
-
-all: test_tp3
-
-%: %.o
-	$(FC) -o $@.exe $^ $(LDFLAGS)
-
-%.o: %.f90
-	$(FC) $(FCFLAGS) -c $<
-
-clean:
-	rm -f *.exe
-	rm -f *.o *.mod *.MOD
-	rm -f xios_client_*.out
-	rm -f xios_client_*.err
Index: XIOS/xios_training/hands-on-3/TP_src/Makefile
===================================================================
--- XIOS/xios_training/hands-on-3/TP_src/Makefile	(revision 2064)
+++ XIOS/xios_training/hands-on-3/TP_src/Makefile	(revision 2069)
@@ -6,5 +6,5 @@
 FCFLAGS= -I$(XIOS_DIR)/inc  -I$(NETCDF_INCDIR)
 # Librairies
-LDFLAGS = -L$(XIOS_DIR)/lib -lxios $(NETCDFLIBS) -lstdc++
+LDFLAGS = -L$(XIOS_DIR)/lib -lxios $(NETCDF_LIBS) -lstdc++
 
 all: test_tp3
Index: XIOS/xios_training/hands-on-3/init-hands-on.sh
===================================================================
--- XIOS/xios_training/hands-on-3/init-hands-on.sh	(revision 2069)
+++ XIOS/xios_training/hands-on-3/init-hands-on.sh	(revision 2069)
@@ -0,0 +1,2 @@
+cp TP_src/* ./
+
Index: XIOS/xios_training/hands-on-3/iodef.xml
===================================================================
--- XIOS/xios_training/hands-on-3/iodef.xml	(revision 2064)
+++ 	(revision )
@@ -1,42 +1,0 @@
-<?xml version="1.0"?>
-<simulation>
- <context id="test">
-   <calendar type="Gregorian" time_origin="2021-01-01" start_date="2021-03" />
-   <axis_definition>
-     <axis id="axis_A" n_glo="10" value="(0,9)[100 200 300 400 500 600 700 800 900 1000]">
-     </axis>
-   </axis_definition>
-
-   <domain_definition>
-     <domain id="domain_A" type="rectilinear" ni_glo="60" nj_glo="20"/>
-   </domain_definition>
-
-   <grid_definition>
-     <grid id="grid_A">
-       <domain domain_ref="domain_A"/>
-       <axis axis_ref="axis_A"/>
-     </grid>
-   </grid_definition>
-   
-   <field_definition>
-     <field id="field_A" name="test_field" operation="instant" grid_ref="grid_A"/>
-   </field_definition>
-
-   <file_definition>
-     <file id="output" name="output" output_freq="1ts" type="one_file">
-       <field id="field_A"/>
-     </file>
-   </file_definition>
-
- </context>
-
-  <context id="xios">
-     <variable_definition>
-        <variable_group id="parameters" >
-          <variable id="print_file" type="bool">true</variable>
-        </variable_group>
-     </variable_definition>
-  </context>
-
-</simulation>
-
Index: XIOS/xios_training/hands-on-3/job.sh
===================================================================
--- XIOS/xios_training/hands-on-3/job.sh	(revision 2064)
+++ 	(revision )
@@ -1,17 +1,0 @@
-#!/bin/bash
-#MSUB -o output.out
-#MSUB -e error.err
-#MSUB -eo
-#MSUB -c 1
-#MSUB -n 4
-#MSUB -X
-#MSUB -x
-#MSUB -T 1800
-#MSUB -q skylake
-#MSUB -A gen0826
-#MSUB -Q test
-#MSUB -m work,scratch
-cd $BRIDGE_MSUB_PWD
-source ../xios_build/arch.env
-
-ccc_mprun ./test_tp3.exe
Index: XIOS/xios_training/hands-on-3/run_ubuntu
===================================================================
--- XIOS/xios_training/hands-on-3/run_ubuntu	(revision 2064)
+++ 	(revision )
@@ -1,1 +1,0 @@
-mpirun -n 4 ./test_tp3.exe
Index: XIOS/xios_training/hands-on-3/test_tp3.f90
===================================================================
--- XIOS/xios_training/hands-on-3/test_tp3.f90	(revision 2064)
+++ 	(revision )
@@ -1,103 +1,0 @@
-PROGRAM test_tp3
-
-  USE XIOS
-  IMPLICIT NONE
-  INCLUDE "mpif.h"
-  INTEGER :: rank
-  INTEGER :: size
-  INTEGER :: ierr
-
-  INTEGER :: comm
-  TYPE(xios_duration) :: dtime
-
-  TYPE(xios_date) :: dorigin
-  CHARACTER(len=20) :: dorigin_str
-
-  TYPE(xios_date) :: dstart
-  CHARACTER(len=20) :: dstart_str
-
-  INTEGER :: axis_size
-  DOUBLE PRECISION, ALLOCATABLE :: axis_value(:)
-
-  CHARACTER(len=20) :: domain_type
-  INTEGER :: ni_glo, nj_glo
-  DOUBLE PRECISION, ALLOCATABLE :: lonvalue(:), latvalue(:)
-  
-  INTEGER :: i, j
-  
-  DOUBLE PRECISION, ALLOCATABLE :: field_A(:,:,:)
- 
-  INTEGER :: ts
- 
-  CALL MPI_INIT(ierr)
-
-  CALL xios_initialize("client",return_comm=comm)
-
-  CALL MPI_COMM_RANK(comm,rank,ierr)
-  CALL MPI_COMM_SIZE(comm,size,ierr)
-  
-  print*, "Hello XIOS from proc", rank
-  
-  CALL xios_context_initialize("test",comm)
-
-  !CALL xios_define_calendar(type="Gregorian") 
-  !We define the calendar type in xml
-
-  CALL xios_get_time_origin(dorigin)
-  CALL xios_date_convert_to_string(dorigin, dorigin_str)
-  if (rank .EQ. 0) print*, "calendar time_origin = ", dorigin_str
-
-  CALL xios_get_start_date(dstart)
-  CALL xios_date_convert_to_string(dstart, dstart_str)
-  if (rank .EQ. 0) print*, "calendar start_date = ", dstart_str
-
-  dtime%second = 3600
-  CALL xios_set_timestep(dtime)
-
-  CALL xios_get_axis_attr("axis_A", n_glo = axis_size)
-  ALLOCATE(axis_value(axis_size))
-  CALL xios_get_axis_attr("axis_A", value = axis_value)
-  if (rank .EQ. 0) print*, "axis value = ", axis_value(:)
-
-  CALL xios_get_domain_attr("domain_A", type = domain_type)
-  CALL xios_get_domain_attr("domain_A", ni_glo = ni_glo, nj_glo=nj_glo)
-  if(rank.EQ.0) print*, "domain type = ", domain_type
-  if(rank.EQ.0) print*, "domain size = ", ni_glo, "*", nj_glo
-
-  ALLOCATE(lonvalue(ni_glo))
-  ALLOCATE(latvalue(nj_glo))
-
-  DO i=1,ni_glo
-    lonvalue(i) = -180 + i * 360/ni_glo
-  ENDDO
-
-  DO j=1,nj_glo
-    latvalue(j) = -90 + j * 180/nj_glo
-  ENDDO
-
-  CALL xios_set_domain_attr("domain_A", lonvalue_1d=lonvalue,latvalue_1d=latvalue)
-
-  CALL xios_close_context_definition()
-
-  ALLOCATE(field_A(ni_glo, nj_glo, axis_size))
-  field_A(:,:,:)=rank
-
-  DO ts=1,4
-    CALL xios_update_calendar(ts)
-    CALL xios_send_field("field_A", field_A)
-  ENDDO
-
-  CALL xios_context_finalize()
-
-  DEALLOCATE(axis_value)
-  DEALLOCATE(lonvalue, latvalue)
-  DEALLOCATE(field_A)
-
-  CALL MPI_COMM_FREE(comm, ierr)
-
-  CALL xios_finalize()
-
-  CALL MPI_FINALIZE(ierr)
-
-END PROGRAM test_tp3
-