Index: XIOS/xios_training/hands-on-10/TP_src/Makefile
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/Makefile	(revision 2091)
+++ XIOS/xios_training/hands-on-10/TP_src/Makefile	(revision 2092)
@@ -2,5 +2,5 @@
 FC = mpif90
 # Variables
-XIOS_DIR = ../xios_build
+XIOS_DIR = ../../xios_build
 # Includes
 FCFLAGS= -I$(XIOS_DIR)/inc  -I$(NETCDF_INCDIR)
Index: XIOS/xios_training/hands-on-10/TP_src/TL_iodef.xml
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/TL_iodef.xml	(revision 2092)
+++ XIOS/xios_training/hands-on-10/TP_src/TL_iodef.xml	(revision 2092)
@@ -0,0 +1,59 @@
+<?xml version="1.0"?>
+
+<simulation>
+
+  <context id="atm">
+    <variable_definition>
+
+      <variable id="timestep"> 1h </variable>
+      <variable id="domain"> lmdz </variable>
+      <variable id="domain_mask"> false </variable>
+      <variable id="axis_mask"> false </variable>
+      <variable id="init_field2D"> rank </variable>
+      <variable id="ni"> 36 </variable>
+      <variable id="nj"> 18 </variable>
+      <variable id="nlev"> 10 </variable>
+      <variable id="pressure_factor"> 0.10 </variable>
+      <variable id="mask3d"> false </variable>
+      
+      <variable id="other_domain"> lmdz </variable>
+      <variable id="other_domain_mask"> false </variable>
+      <variable id="other_axis_mask"> false </variable>
+      <variable id="other_init_field2D"> academic </variable>
+      <variable id="other_ni"> 36 </variable>
+      <variable id="other_nj"> 18 </variable>
+      <variable id="other_nlev"> 10 </variable>
+      <variable id="other_pressure_factor"> 0.10 </variable>
+      <variable id="other_mask3d"> false </variable>
+      
+    </variable_definition>
+  </context>
+
+
+
+  <context id="atm" src="./context_atm.xml"/>
+  <context id="grid_dynamico" src="./context_grid_dynamico.xml"/>
+  
+  <context id="xios">
+    <variable_definition>
+      <variable_group id="buffer">
+        <variable id="min_buffer_size" type="int">10000000</variable>
+        <variable id="optimal_buffer_size" type="string">performance</variable>
+        <variable id="buffer_factor_size" type="double">0.8</variable> 
+      </variable_group>
+
+      <variable_group id="parameters" >
+        <variable id="using_server" type="bool">true</variable>
+        <variable id="info_level" type="int">100</variable>
+        <variable id="print_file" type="bool">true</variable>
+        <variable id="using_server2" type="bool">true</variable>
+        <variable id="ratio_server2" type="int">50</variable>
+        <variable id="number_pools_server2" type="int">1</variable>
+        <variable id="pure_one_sided" type="bool">false</variable>
+        <variable id="check_event_sync" type="bool">true</variable>
+      </variable_group>
+      <variable id="activate_non_distributed_transformation" type="bool">false</variable>
+    </variable_definition>
+  </context>
+
+</simulation>
Index: XIOS/xios_training/hands-on-10/TP_src/context_atm.xml
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/context_atm.xml	(revision 2091)
+++ XIOS/xios_training/hands-on-10/TP_src/context_atm.xml	(revision 2092)
@@ -419,9 +419,9 @@
     </file>
 
-    <file name="output_interpolate_domain" output_freq="1h" type="one_file" enabled="true">
+    <file name="output_interpolate_domain" output_freq="1h" type="one_file" enabled="false">
        <field field_ref="field2D" name="field2D_recti" grid_ref="grid2D_recti" />
     </file>
 
-    <file name="output_interpolate_axis" output_freq="1h" type="one_file" enabled="true">
+    <file name="output_interpolate_axis" output_freq="1h" type="one_file" enabled="false">
        <field field_ref="field3D" name="field3D_interpolate_axis" grid_ref="grid3D_interp_axis"/>
     </file>
Index: XIOS/xios_training/hands-on-10/TP_src/iodef.xml
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/iodef.xml	(revision 2091)
+++ XIOS/xios_training/hands-on-10/TP_src/iodef.xml	(revision 2092)
@@ -16,8 +16,4 @@
       <variable id="pressure_factor"> 0.10 </variable>
       <variable id="mask3d"> false </variable>
-<!--      <variable id="domain_proc_frac">3</variable>
-      <variable id="axis_proc_frac">2</variable>
-      <variable id="axis_proc_n">2</variable>
-      <variable id="ensemble_proc_n">2</variable> -->
       
       <variable id="other_domain"> lmdz </variable>
@@ -30,8 +26,4 @@
       <variable id="other_pressure_factor"> 0.10 </variable>
       <variable id="other_mask3d"> false </variable>
-<!--      <variable id="other_domain_proc_frac">3</variable>
-      <variable id="other_axis_proc_frac">2</variable>
-      <variable id="other_axis_proc_n">2</variable>
-      <variable id="other_ensemble_proc_n">2</variable> -->
       
     </variable_definition>
@@ -46,7 +38,7 @@
     <variable_definition>
       <variable_group id="buffer">
-  <variable id="min_buffer_size" type="int">10000000</variable>
-  <variable id="optimal_buffer_size" type="string">performance</variable>
-  <variable id="buffer_factor_size" type="double">0.8</variable> 
+        <variable id="min_buffer_size" type="int">10000000</variable>
+        <variable id="optimal_buffer_size" type="string">performance</variable>
+        <variable id="buffer_factor_size" type="double">0.8</variable> 
       </variable_group>
 
@@ -55,5 +47,5 @@
         <variable id="info_level" type="int">100</variable>
         <variable id="print_file" type="bool">true</variable>
-        <variable id="using_server2" type="bool">true</variable>
+        <variable id="using_server2" type="bool">false</variable>
         <variable id="ratio_server2" type="int">50</variable>
         <variable id="number_pools_server2" type="int">1</variable>
Index: XIOS/xios_training/hands-on-10/TP_src/run_servered
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/run_servered	(revision 2091)
+++ XIOS/xios_training/hands-on-10/TP_src/run_servered	(revision 2092)
@@ -1,1 +1,1 @@
-mpirun -n 2 ./generic_testcase.exe : -n 2 ../xios_build/bin/xios_server.exe
+mpirun -n 2 ./generic_testcase.exe : -n 2 ../../xios_build/bin/xios_server.exe
Index: XIOS/xios_training/hands-on-10/TP_src/servered_param.def
===================================================================
--- XIOS/xios_training/hands-on-10/TP_src/servered_param.def	(revision 2092)
+++ XIOS/xios_training/hands-on-10/TP_src/servered_param.def	(revision 2092)
@@ -0,0 +1,4 @@
+&params_run
+duration='1h'
+nb_proc_atm=2
+/
Index: XIOS/xios_training/hands-on-10/init-hands-on.sh
===================================================================
--- XIOS/xios_training/hands-on-10/init-hands-on.sh	(revision 2091)
+++ XIOS/xios_training/hands-on-10/init-hands-on.sh	(revision 2092)
@@ -1,2 +1,24 @@
 cp TP_src/* ./
 
+mkdir -p attached_mode
+mkdir -p servered_mode
+mkdir -p TL_servered_mode
+
+cp TP_src/* ./attached_mode
+cp TP_src/* ./servered_mode
+cp TP_src/* ./TL_servered_mode
+
+rm -f attached_mode/TL_iodef.xml
+rm -f attached_mode/run_servered
+rm -f attached_mode/servered_param.def
+
+rm -f servered_mode/TL_iodef.xml
+rm -f servered_mode/run_attached
+rm -f servered_mode/param.def
+mv servered_mode/servered_param.def servered_mode/param.def
+
+rm -f TL_servered_mode/iodef.xml
+mv TL_servered_mode/TL_iodef.xml TL_servered_mode/iodef.xml
+rm -f TL_servered_mode/run_attached
+rm -f TL_servered_mode/param.def
+mv TL_servered_mode/servered_param.def TL_servered_mode/param.def