Index: XIOS/xios_training/hands-on-11/TP_src/iodef.xml
===================================================================
--- XIOS/xios_training/hands-on-11/TP_src/iodef.xml	(revision 2103)
+++ XIOS/xios_training/hands-on-11/TP_src/iodef.xml	(revision 2104)
@@ -16,8 +16,4 @@
       <variable id="pressure_factor"> 0.10 </variable>
       <variable id="mask3d"> false </variable>
-<!--      <variable id="domain_proc_frac">3</variable>
-      <variable id="axis_proc_frac">2</variable>
-      <variable id="axis_proc_n">2</variable>
-      <variable id="ensemble_proc_n">2</variable> -->
       
       <variable id="other_domain"> lmdz </variable>
@@ -30,8 +26,4 @@
       <variable id="other_pressure_factor"> 0.10 </variable>
       <variable id="other_mask3d"> false </variable>
-<!--      <variable id="other_domain_proc_frac">3</variable>
-      <variable id="other_axis_proc_frac">2</variable>
-      <variable id="other_axis_proc_n">2</variable>
-      <variable id="other_ensemble_proc_n">2</variable> -->
       
     </variable_definition>
@@ -46,7 +38,7 @@
     <variable_definition>
       <variable_group id="buffer">
-      <variable id="min_buffer_size" type="int">10000000</variable>
-      <variable id="optimal_buffer_size" type="string">performance</variable>
-      <variable id="buffer_factor_size" type="double">0.8</variable> 
+        <variable id="min_buffer_size" type="int">10000000</variable>
+        <variable id="optimal_buffer_size" type="string">performance</variable>
+        <variable id="buffer_factor_size" type="double">0.8</variable> 
       </variable_group>
 
@@ -60,5 +52,5 @@
         <variable id="pure_one_sided" type="bool">false</variable>
         <variable id="check_event_sync" type="bool">true</variable>
-        <variable id="xios_stack" type="bool">true</variable>
+        <variable id="xios_stack" type="bool">false</variable>
       </variable_group>
       <variable id="activate_non_distributed_transformation" type="bool">false</variable>
Index: XIOS/xios_training/hands-on-11/answer/iodef.xml
===================================================================
--- XIOS/xios_training/hands-on-11/answer/iodef.xml	(revision 2104)
+++ XIOS/xios_training/hands-on-11/answer/iodef.xml	(revision 2104)
@@ -0,0 +1,60 @@
+<?xml version="1.0"?>
+
+<simulation>
+
+  <context id="atm">
+    <variable_definition>
+
+      <variable id="timestep"> 1h </variable>
+      <variable id="domain"> lmdz </variable>
+      <variable id="domain_mask"> false </variable>
+      <variable id="axis_mask"> false </variable>
+      <variable id="init_field2D"> rank </variable>
+      <variable id="ni"> 36 </variable>
+      <variable id="nj"> 18 </variable>
+      <variable id="nlev"> 10 </variable>
+      <variable id="pressure_factor"> 0.10 </variable>
+      <variable id="mask3d"> false </variable>
+      
+      <variable id="other_domain"> lmdz </variable>
+      <variable id="other_domain_mask"> false </variable>
+      <variable id="other_axis_mask"> false </variable>
+      <variable id="other_init_field2D"> academic </variable>
+      <variable id="other_ni"> 36 </variable>
+      <variable id="other_nj"> 18 </variable>
+      <variable id="other_nlev"> 10 </variable>
+      <variable id="other_pressure_factor"> 0.10 </variable>
+      <variable id="other_mask3d"> false </variable>
+      
+    </variable_definition>
+  </context>
+
+
+
+  <context id="atm" src="./context_atm.xml"/>
+  <context id="grid_dynamico" src="./context_grid_dynamico.xml"/>
+  
+  <context id="xios">
+    <variable_definition>
+      <variable_group id="buffer">
+        <variable id="min_buffer_size" type="int">10000000</variable>
+        <variable id="optimal_buffer_size" type="string">performance</variable>
+        <variable id="buffer_factor_size" type="double">0.8</variable> 
+      </variable_group>
+
+      <variable_group id="parameters" >
+        <variable id="using_server" type="bool">true</variable>
+        <variable id="info_level" type="int">100</variable>
+        <variable id="print_file" type="bool">true</variable>
+        <variable id="using_server2" type="bool">true</variable>
+        <variable id="ratio_server2" type="int">50</variable>
+        <variable id="number_pools_server2" type="int">1</variable>
+        <variable id="pure_one_sided" type="bool">false</variable>
+        <variable id="check_event_sync" type="bool">true</variable>
+        <variable id="xios_stack" type="bool">true</variable>
+      </variable_group>
+      <variable id="activate_non_distributed_transformation" type="bool">false</variable>
+    </variable_definition>
+  </context>
+
+</simulation>